; Compiled with: OshonSoft PIC Basic Compiler v7.971
; Microcontroller model: PIC12F629
; Clock frequency: 4.0MHz
;
	R0L EQU 0x020
	R0H EQU 0x021
	R1L EQU 0x022
	R1H EQU 0x023
	R0HL EQU 0x020
	R1HL EQU 0x022
	R1HL0HL EQU 0x020
	LONG_0 EQU 0x024
	LONG_1 EQU 0x025
	LONG_2 EQU 0x026
	LONG_3 EQU 0x027
	LONG1 EQU 0x024
	ARRARG_0 EQU 0x028
	ARRARG_1 EQU 0x029
	ARRARG_2 EQU 0x02A
	ARRARG_3 EQU 0x02B
;       The address of 'ADFRegs' (array 6) (long) (global) is 0x034
;       The address of 'Sel' (byte) (global) is 0x02C
;       The address of 'i' (byte) (global) is 0x02E
;       The address of 'RegVal' (long) (WR32) is 0x030
;       The address of 'ByteVal' (byte) (WByte) is 0x02D
;       The address of 'j' (byte) (WByte) is 0x02F
;       The address of 'adf435x_LE' (bit) (global) is 0x005,2
;       The address of 'ADF435x_DATA' (bit) (global) is 0x005,1
;       The address of 'ADF435x_CLK' (bit) (global) is 0x005,0
;       The address of 'SW1' (bit) (global) is 0x005,4
;       The address of 'SW2' (bit) (global) is 0x005,5
	ORG 0x0000
	BCF PCLATH,4
	BCF PCLATH,3
	GOTO L0004
	ORG 0x0004
	RETFIE
; User code start
L0004:
; 1: Define CONFIG = 0x31e4
;       The value of 'CONFIG' is 12772
; 2: 
; 3: 'Ultra Simple ADF435x programmer
; 4: 'VK3DIP August 2020 V1.0
; 5: 'Modeled on version by G7DOE
; 6: 
; 7: 'Uses 12f629 running at 3.3V
; 8: 
; 9: Symbol adf435x_LE = GP2
; 10: Symbol ADF435x_DATA = GP1
; 11: Symbol ADF435x_CLK = GP0
; 12: Symbol SW1 = GP4
; 13: Symbol SW2 = GP5
; 14: 'GP3 used as MCLR
; 15: 
; 16: TRISIO = %00111000  'GP0 , GP1, GP2 2 out, rest set to input.
	MOVLW 0x38
	BSF STATUS,RP0
	MOVWF TRISIO
	BCF STATUS,RP0
; 17: CMCON = %00000111  'Comparator off
	MOVLW 0x07
	MOVWF CMCON
; 18: WPU = %00111000  'weak pull ups off for outputs, on for inputs
	MOVLW 0x38
	BSF STATUS,RP0
	MOVWF WPU
; 19: OPTION.7 = 0  'pull ups on
	BCF OPTION_REG,7
	BCF STATUS,RP0
; 20: Disable  'no interupts
	BCF INTCON,GIE
; 21: 
; 22: 'Uses ADF425x register values as determined by AD Config Tool
; 23: 'eg 2256MHz, 10MHz ref, -1dBm out , Muxout Dig Lock Detect
; 24: '{0x708018, 0x8008029, 0x18004E42, 0x4B3, 0x85002C, 0x580005}
; 25: 
; 26: Dim ADFRegs(6) As Long
; 27: ADFRegs(0) = 0x00708018  'default 2256MHz (10MHz) -1dBm
	MOVLW 0x18
	MOVWF 0x034
	MOVLW 0x80
	MOVWF 0x035
	MOVLW 0x70
	MOVWF 0x036
	CLRF 0x037
; 28: ADFRegs(1) = 0x08008029
	MOVLW 0x29
	MOVWF 0x038
	MOVLW 0x80
	MOVWF 0x039
	CLRF 0x03A
	MOVLW 0x08
	MOVWF 0x03B
; 29: ADFRegs(2) = 0x18004e42
	MOVLW 0x42
	MOVWF 0x03C
	MOVLW 0x4E
	MOVWF 0x03D
	CLRF 0x03E
	MOVLW 0x18
	MOVWF 0x03F
; 30: ADFRegs(3) = 0x000004b3
	MOVLW 0xB3
	MOVWF 0x040
	MOVLW 0x04
	MOVWF 0x041
	CLRF 0x042
	CLRF 0x043
; 31: ADFRegs(4) = 0x0085002c
	MOVLW 0x2C
	MOVWF 0x044
	CLRF 0x045
	MOVLW 0x85
	MOVWF 0x046
	CLRF 0x047
; 32: ADFRegs(5) = 0x00580005
	MOVLW 0x05
	MOVWF 0x048
	CLRF 0x049
	MOVLW 0x58
	MOVWF 0x04A
	CLRF 0x04B
; 33: 
; 34: Main:
L0001:
; 35: Dim Sel As Byte
; 36: Sel = 0
	CLRF 0x02C
; 37: Sel.0 = SW1
	BCF 0x02C,0
	BTFSC GPIO,4
	BSF 0x02C,0
; 38: Sel.1 = SW2
	BCF 0x02C,1
	BTFSC GPIO,5
	BSF 0x02C,1
; 39: 
; 40: Select Case Sel
; 41: Case 0
	MOVF 0x02C,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0005
; 42: 'change To -4dBm
; 43: ADFRegs(4) = 0x00850024
	MOVLW 0x24
	MOVWF 0x044
	CLRF 0x045
	MOVLW 0x85
	MOVWF 0x046
	CLRF 0x047
; 44: Case 1
	GOTO L0006
L0005:
	MOVF 0x02C,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0007
; 45: 'leave as is for -1dBm
; 46: ADFRegs(4) = 0x0085002c
	MOVLW 0x2C
	MOVWF 0x044
	CLRF 0x045
	MOVLW 0x85
	MOVWF 0x046
	CLRF 0x047
; 47: Case 2
	GOTO L0008
L0007:
	MOVF 0x02C,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0009
; 48: 'change to +2dBm
; 49: ADFRegs(4) = 0x00850034
	MOVLW 0x34
	MOVWF 0x044
	CLRF 0x045
	MOVLW 0x85
	MOVWF 0x046
	CLRF 0x047
; 50: Case Else  'ie 3
	GOTO L0010
L0009:
; 51: 'change to +5dBm
; 52: ADFRegs(4) = 0x0085003c
	MOVLW 0x3C
	MOVWF 0x044
	CLRF 0x045
	MOVLW 0x85
	MOVWF 0x046
	CLRF 0x047
; 53: EndSelect
L0010:
L0008:
L0006:
; 54: 
; 55: 'program ADF435x starting with R5
; 56: Dim i As Byte
; 57: For i = 5 To 0 Step -1
	MOVLW 0x05
	MOVWF 0x02E
L0011:
	MOVLW 0x00
	SUBWF 0x02E,W
	BTFSS STATUS,C
	GOTO L0012
; 58: Call WR32(ADFRegs(i))
	BCF STATUS,IRP
	BCF STATUS,C
	RLF 0x02E,W
	MOVWF FSR
	ADDWF FSR,W
	ADDLW 0x34
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x030
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x031
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x032
	INCF FSR,F
	MOVF INDF,W
	MOVWF 0x033
	CALL L0002
; 59: Next i
	MOVLW 0x01
	SUBWF 0x02E,F
	BTFSC STATUS,C
	GOTO L0011
L0012:
; 60: ASM:        SLEEP
	SLEEP
; 61: End
L0013:	GOTO L0013
; 62: Proc WR32(RegVal As Long)
L0002:
; 63: 'Write Bytes starting with MSByte
; 64: Call WByte(RegVal.4B)
	MOVF 0x033,W
	MOVWF 0x02D
	CALL L0003
; 65: Call WByte(RegVal.3B)
	MOVF 0x032,W
	MOVWF 0x02D
	CALL L0003
; 66: Call WByte(RegVal.HB)
	MOVF 0x031,W
	MOVWF 0x02D
	CALL L0003
; 67: Call WByte(RegVal.LB)
	MOVF 0x030,W
	MOVWF 0x02D
	CALL L0003
; 68: 'latch data into register
; 69: adf435x_LE = 1
	BSF GPIO,2
; 70: adf435x_LE = 0
	BCF GPIO,2
; 71: End Proc
	RETURN
; 72: Proc WByte(ByteVal As Byte)
L0003:
; 73: 'iterate over the 8 bits MSBit first
; 74: Dim j As Byte
; 75: For j = 7 To 0 Step -1
	MOVLW 0x07
	MOVWF 0x02F
L0014:
	MOVLW 0x00
	SUBWF 0x02F,W
	BTFSS STATUS,C
	GOTO L0015
; 76: ADF435x_DATA = ByteVal.j
	MOVF 0x02D,W
	MOVWF R1L
	MOVF 0x02F,W
	MOVWF R0H
	CALL BI01
	BCF GPIO,1
	BTFSC R1L,0
	BSF GPIO,1
; 77: 'clock data into shift register
; 78: ADF435x_CLK = 1
	BSF GPIO,0
; 79: ADF435x_CLK = 0
	BCF GPIO,0
; 80: Next j
	MOVLW 0x01
	SUBWF 0x02F,F
	BTFSC STATUS,C
	GOTO L0014
L0015:
; 81: End Proc
	RETURN
; 82: 
; Library code
; End of user code
L0016:	GOTO L0016
;
;
; Bit Index Routine
BI01:	INCF R0H,F
	RLF R1L,F
BI02:	RRF R1L,F
	DECFSZ R0H,F
	GOTO BI02
	RETURN
BI10:	MOVLW 0x09
	MOVWF R1H
	INCF R0H,F
	RLF R0L,F
	GOTO BI11
BI12:	BCF STATUS,C
	BTFSC R0L,0
	BSF STATUS,C
BI11:	RRF R0L,F
	DECF R0H,F
	BTFSC STATUS,Z
	CALL BI13
	DECFSZ R1H,F
	GOTO BI12
	RETURN
BI13:	BCF R0L,0
	BTFSC R1L,0
	BSF R0L,0
	RETURN
;
;
;
;
; Configuration settings
	ORG 0x2007
	DW 0x31E4
; End of listing
	END
