Define CONFIG = 0x31e4

'Ultra Simple ADF435x programmer
'VK3DIP August 2020 V1.0
'Modeled on version by G7DOE

'Uses 12f629 running at 3.3V

Symbol adf435x_LE = GP2
Symbol ADF435x_DATA = GP1
Symbol ADF435x_CLK = GP0
Symbol SW1 = GP4
Symbol SW2 = GP5
'GP3 used as MCLR

TRISIO = %00111000  'GP0 , GP1, GP2 2 out, rest set to input.
CMCON = %00000111  'Comparator off
WPU = %00111000  'weak pull ups off for outputs, on for inputs
OPTION.7 = 0  'pull ups on
Disable  'no interupts

'Uses ADF425x register values as determined by AD Config Tool
'eg 2256MHz, 10MHz ref, -1dBm out , Muxout Dig Lock Detect
'{0x708018, 0x8008029, 0x18004E42, 0x4B3, 0x85002C, 0x580005}

Dim ADFRegs(6) As Long
ADFRegs(0) = 0x00708018  'default 2256MHz (10MHz) -1dBm
ADFRegs(1) = 0x08008029
ADFRegs(2) = 0x18004e42
ADFRegs(3) = 0x000004b3
ADFRegs(4) = 0x0085002c
ADFRegs(5) = 0x00580005

Main:
Dim Sel As Byte
Sel = 0
Sel.0 = SW1
Sel.1 = SW2

Select Case Sel
	Case 0
	'change To -4dBm
		ADFRegs(4) = 0x00850024
	Case 1
	'leave as is for -1dBm
		ADFRegs(4) = 0x0085002c
	Case 2
	'change to +2dBm
		ADFRegs(4) = 0x00850034
	Case Else  'ie 3
	'change to +5dBm
		ADFRegs(4) = 0x0085003c
EndSelect

'program ADF435x starting with R5
Dim i As Byte
For i = 5 To 0 Step -1
	Call WR32(ADFRegs(i))
Next i
ASM:        SLEEP
End                                               
Proc WR32(RegVal As Long)
	'Write Bytes starting with MSByte
	Call WByte(RegVal.4B)
	Call WByte(RegVal.3B)
	Call WByte(RegVal.HB)
	Call WByte(RegVal.LB)
	'latch data into register
adf435x_LE = 1
	adf435x_LE = 0
End Proc                                          
Proc WByte(ByteVal As Byte)
'iterate over the 8 bits MSBit first
	Dim j As Byte
	For j = 7 To 0 Step -1
		ADF435x_DATA = ByteVal.j
		'clock data into shift register
		ADF435x_CLK = 1
		ADF435x_CLK = 0
	Next j
End Proc                                          

